/*

Copyright Yann OLLIVIER 1997-1999

This software may be freely distributed as is, including
this whole notice.

It may be modified, but any modification should include this whole notice as 
is and a description of the changes made.

This software may not be sold.

This software or any modified version of it may be freely used in free
programs. The program should include a copy of this whole notice. If you
want to use it in a program you sell, contact me

This software comes with absolutely no warranty.

*/

#include"eqdiff.h"

void Fenetre::OptDialog()
{
  if(Sel==-1||!Sel)return;
  if(!(GTK_TOGGLE_BUTTON(DiffRB)->active||
     GTK_TOGGLE_BUTTON(ChampRB)->active||
     GTK_TOGGLE_BUTTON(NivRB)->active))return;
  if(LFonctions[Sel].opt==1)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ContRB),TRUE);
  else
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ArrRB),TRUE);
  if(LFonctions[Sel].TestPtI)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(TestPtICB),TRUE);
  if(LFonctions[Sel].TestPts)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(TestPtsCB),TRUE);
  gtk_grab_add(OptDial);
  gtk_widget_show(OptDial);
}

void Fenetre::OptDialogOK()
{
  if(GTK_TOGGLE_BUTTON(ContRB)->active)LFonctions[Sel].opt=1;else LFonctions[Sel].opt=0;
  if(GTK_TOGGLE_BUTTON(TestPtICB)->active)LFonctions[Sel].TestPtI=1;else LFonctions[Sel].TestPtI=0;
  if(GTK_TOGGLE_BUTTON(TestPtsCB)->active)LFonctions[Sel].TestPts=1;else LFonctions[Sel].TestPts=0;  
  gtk_grab_remove(OptDial);
  gtk_widget_hide(OptDial);
}

void Fenetre::OptDialogCancel()
{
  gtk_grab_remove(OptDial);
  gtk_widget_hide(OptDial);
}

void Fenetre::FuncColorSelDialog()
{
  if(Sel==-1)return;
  double color[3];
  color[0]=FuncColor_temp.red/65536.;color[1]=FuncColor_temp.green/65536.;color[2]=FuncColor_temp.blue/65536.;
  gtk_color_selection_set_color(GTK_COLOR_SELECTION(GTK_COLOR_SELECTION_DIALOG(FuncColorSelDial)->colorsel),color);
  gtk_grab_add(FuncColorSelDial);
  gtk_widget_show(FuncColorSelDial);
}

void Fenetre::FuncColorSelDialogOK()
{
  gdouble color[3];
  gtk_color_selection_get_color(GTK_COLOR_SELECTION(GTK_COLOR_SELECTION_DIALOG(FuncColorSelDial)->colorsel),color);
  guint red,green,blue;
  red=(guint)(color[0]*65535.);
  green=(guint)(color[1]*65535.);
  blue=(guint)(color[2]*65535.);
  FuncColor_temp=RGB(red,green,blue);
  gtk_grab_remove(FuncColorSelDial);
  gtk_widget_hide(FuncColorSelDial);
}

void Fenetre::FuncColorSelDialogCancel()
{
  gtk_grab_remove(FuncColorSelDial);
  gtk_widget_hide(FuncColorSelDial);
}

void Fenetre::FixeTypes()
{
  char* rectx[1]={"Rect y(x)"};
  char* recty[1]={"Rect x(y)"};
  char* rectxy[1]={"Rect x,y (t)"};
  char* polr[1]={"Pol r(a)"};
  char* pola[1]={"Pol a(r)"};
  char* polra[1]={"Pol a,r (t)"};
  char* rectxp[1]={"Rect y'(x,y)"};
  char* rectyp[1]={"Rect x'(y,x)"};
  char* rectxyp[1]={"Rect x',y' (x,y)"};
  char* f[1]={"f(x,y,r,a)"};
  char* un[1]={"(unavailable)"};

  gtk_clist_clear(GTK_CLIST(TypeList));
  if(GTK_TOGGLE_BUTTON(FoncRB)->active){
    gtk_clist_append(GTK_CLIST(TypeList),rectx);
    gtk_clist_append(GTK_CLIST(TypeList),recty);
    gtk_clist_append(GTK_CLIST(TypeList),rectxy);
    gtk_clist_append(GTK_CLIST(TypeList),polr);
    gtk_clist_append(GTK_CLIST(TypeList),pola);
    gtk_clist_append(GTK_CLIST(TypeList),polra);
  }else if(GTK_TOGGLE_BUTTON(DiffRB)->active){
    gtk_clist_append(GTK_CLIST(TypeList),rectxp);
    gtk_clist_append(GTK_CLIST(TypeList),rectyp);
    gtk_clist_append(GTK_CLIST(TypeList),rectxyp);
    // Polar diff eqs. to come some day
  }else if(GTK_TOGGLE_BUTTON(NivRB)->active||GTK_TOGGLE_BUTTON(ChampRB)->active){
    gtk_clist_append(GTK_CLIST(TypeList),f);
  }else if(GTK_TOGGLE_BUTTON(Diff2RB)->active){
    gtk_clist_append(GTK_CLIST(TypeList),un);
  }
}

void Fenetre::FixeParams()
{
  if(coord==-1||GTK_TOGGLE_BUTTON(NivRB)->active||GTK_TOGGLE_BUTTON(ChampRB)->active){
    gtk_frame_set_label(GTK_FRAME(IntSt),"Interval");
    gtk_widget_set_sensitive(IntSt,FALSE);
  }
  if(GTK_TOGGLE_BUTTON(FoncRB)->active){
    gtk_widget_set_sensitive(IntSt,TRUE);
    switch(coord){
    case 0:gtk_frame_set_label(GTK_FRAME(IntSt),"Interval of x (or SCREEN)");break;
    case 1:gtk_frame_set_label(GTK_FRAME(IntSt),"Interval of y (or SCREEN)");break;
    case 3:gtk_frame_set_label(GTK_FRAME(IntSt),"Interval of a");break;
    case 4:gtk_frame_set_label(GTK_FRAME(IntSt),"Interval of r (or SCREEN)");break;
    case 2:gtk_frame_set_label(GTK_FRAME(IntSt),"Interval of t");break;
    case 5:gtk_frame_set_label(GTK_FRAME(IntSt),"Interval of t");break;
    }
  }
  if(GTK_TOGGLE_BUTTON(DiffRB)->active){
    gtk_widget_set_sensitive(IntSt,TRUE);
    switch(coord){
    case 0:gtk_frame_set_label(GTK_FRAME(IntSt),"Interval of x (or SCREEN)");break;
    case 1:gtk_frame_set_label(GTK_FRAME(IntSt),"Interval of y (or SCREEN)");break;
    case 2:
      gtk_frame_set_label(GTK_FRAME(IntSt),"Interval");
      gtk_widget_set_sensitive(IntSt,FALSE);
      break;
    }
  }
}

void Fenetre::Nature()
{
  FixeTypes();
  if(GTK_TOGGLE_BUTTON(FoncRB)->active)
    {gtk_widget_set_sensitive(ZCalcCB,TRUE);gtk_widget_set_sensitive(OptB,FALSE);};
  if(GTK_TOGGLE_BUTTON(DiffRB)->active||GTK_TOGGLE_BUTTON(NivRB)->active||GTK_TOGGLE_BUTTON(ChampRB)->active)
    {gtk_widget_set_sensitive(ZCalcCB,FALSE);gtk_widget_set_sensitive(OptB,TRUE);};
  if(GTK_TOGGLE_BUTTON(NivRB)->active||GTK_TOGGLE_BUTTON(ChampRB)->active)
    gtk_clist_select_row(GTK_CLIST(TypeList),0,0);
  if(GTK_TOGGLE_BUTTON(ChampRB)->active&&Sel>0)LFonctions[Sel].opt=0;
  if(GTK_TOGGLE_BUTTON(FoncRB)->active){
    if(Sel==-1)
      gtk_clist_select_row(GTK_CLIST(TypeList),0,0);
    else
      gtk_clist_select_row(GTK_CLIST(TypeList),LFonctions[Sel].t,0);
  }
  if(GTK_TOGGLE_BUTTON(DiffRB)->active){
    if(Sel==-1||LFonctions[Sel].t>2)
      gtk_clist_select_row(GTK_CLIST(TypeList),0,0);
    else
      gtk_clist_select_row(GTK_CLIST(TypeList),LFonctions[Sel].t,0);
  }
  FixeParams();
}

void Fenetre::Coords(int s)
{
  coord=s;FixeParams();
}

void Fenetre::FuncOK()
{
  if(Sel==-1)return;TFonction*pf=&LFonctions[Sel];
  char Ind=0;
  RFunction**ppfuncs=new RFunction*[!LFonctions-2];
  int i;for(i=1;i<!LFonctions;i++)
    if(i!=Sel)ppfuncs[i-(i>Sel?2:1)]=&LFonctions[i].func;
  if(pf->hp->color!=FuncColor_temp){
    pf->hp->color=FuncColor_temp;
    GdkColormap *colormap;
    colormap = gdk_window_get_colormap (drawing_area->window);
    gdk_color_alloc (colormap,&pf->hp->color);
    Ind=1;
  }
  if(GTK_TOGGLE_BUTTON(FoncRB)->active&&pf->Diff){
    pf->Diff=0;pf->Calc=0;
  }else if(GTK_TOGGLE_BUTTON(DiffRB)->active&&pf->Diff!=1){
    pf->Diff=1;pf->Calc=0;
  }else if(GTK_TOGGLE_BUTTON(NivRB)->active&&pf->Diff!=2){
    pf->Diff=2;pf->Calc=0;
  }else	if(GTK_TOGGLE_BUTTON(ChampRB)->active&&pf->Diff!=3){
    pf->Diff=3;pf->Calc=0;
  }else if(GTK_TOGGLE_BUTTON(Diff2RB)->active&&pf->Diff!=4){
    pf->Diff=4;pf->Calc=0;
  }
  if(coord!=pf->t){pf->t=coord;pf->Calc=0;}
  if(Sel&&(ExprEdCh||!pf->Calc)){
    ExprEdCh=0;
    char* s=gtk_entry_get_text(GTK_ENTRY(ExprEd));
    //    delete pf->pexpr;
    if(pf->Diff==0){
      RVar**ppvar=NULL;
      switch(pf->t){
      case 0:ppvar=&pxvar;break;
      case 1:ppvar=&pyvar;break;
      case 3:ppvar=&pavar;break;
      case 4:ppvar=&prvar;break;
      case 2:case 5:ppvar=&ptvar;break;};
      pf->pexpr=new ROperation(s,1,ppvar,!LFonctions-2,ppfuncs);
      pf->func=RFunction(*pf->pexpr,1,ppvar);pf->func.SetName(pf->nom);
      *pf->pexprder=pf->pexpr->Diff(**ppvar);
      pf->Calc=0;
    }else if(pf->Diff==1){
      RVar*ppvar[2];pf->Calc=1;
      if(!pf->LCourbes){pf->LCourbes.Destroy();Ind=1;};
      switch(pf->t){
      case 0:case 1:case 2:ppvar[0]=pxvar;ppvar[1]=pyvar;break;
      };
      pf->pexpr=new ROperation(s,2,ppvar,!LFonctions-2,ppfuncs);
      pf->func=RFunction(*pf->pexpr,2,ppvar);pf->func.SetName(pf->nom);
      *pf->pexprder=pf->pexpr->Diff(*ppvar[0]);
      *pf->pexprder2=pf->pexpr->Diff(*ppvar[1]);
    }else{//pf->Diff==2 ou 3
      RVar*ppvar[4];pf->Calc=1;
      if(!pf->LCourbes){pf->LCourbes.Destroy();Ind=1;};
      ppvar[0]=pxvar;ppvar[1]=pyvar;ppvar[2]=prvar;ppvar[3]=pavar;
      pf->pexpr=new ROperation(s,4,ppvar,!LFonctions-2,ppfuncs);
      ROperation opx(*pxvar),opy(*pyvar);
      *pf->pexpr=pf->pexpr->Substitute(*prvar,sqrt((opx^2)+((opy)^2)));
      *pf->pexpr=pf->pexpr->Substitute(*pavar,atan((opy,opx)));
      pf->func=RFunction(*pf->pexpr,2,ppvar);pf->func.SetName(pf->nom);
      delete pf->pexprder;delete pf->pexprder2;
      pf->pexprder=DeriveX(pf->pexpr);pf->pexprder2=DeriveY(pf->pexpr);
    }
  }
  pf->Active=(GTK_TOGGLE_BUTTON(ActiveCB)->active?1:0);
  pf->ZCalc=(GTK_TOGGLE_BUTTON(ZCalcCB)->active?1:0);
  char * Texte;
  if(drEdCh){
    drEdCh=0;
    Texte=gtk_entry_get_text(GTK_ENTRY(drEd));
    double dr=atof(Texte);
    if(dr>1E-8){
      pf->dr=dr;if(!pf->Diff)pf->Calc=0;
    }else MessageBox("Modify","Precision too small");
  }
  if(minpEdCh){
    minpEdCh=0;
    Texte=gtk_entry_get_text(GTK_ENTRY(minpEd));
    if(!strcmp(Texte,"SCREEN")||!strcmp(Texte,"screen"))
      pf->minp=ErrVal;else pf->minp=atof(Texte);
    if(!pf->Diff)pf->Calc=0;
  }
  if(maxpEdCh){
    maxpEdCh=0;
    Texte=gtk_entry_get_text(GTK_ENTRY(maxpEd));
    if(!strcmp(Texte,"SCREEN")||!strcmp(Texte,"screen"))
      pf->maxp=ErrVal;else pf->maxp=atof(Texte);
    if(!pf->Diff)pf->Calc=0;
  }
  if(Sel){
    char*s=pf->pexpr->Expr();
    if(!pf->pexpr->HasError()){gtk_entry_set_text(GTK_ENTRY(ExprEd),s);ExprEdCh=0;}
    else MessageBox("Modify","Error in the expression");
    if(pf->Diff&&!StringInFoncSelL(pf->nom)){
      FoncSelList=g_list_append(FoncSelList,pf->nom);
      gtk_combo_set_popdown_strings(GTK_COMBO(FoncSelL),FoncSelList);
      gtk_label_set_text(GTK_LABEL(AideSt),"Click on the window to draw a curve of the selected function");
    }
    if(!pf->Diff&&StringInFoncSelL(pf->nom)){
      FoncSelList=g_list_remove(FoncSelList,pf->nom);
      gtk_combo_set_popdown_strings(GTK_COMBO(FoncSelL),FoncSelList);
      if(PFoncSel==pf){
	gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(FoncSelL)->entry),"");
	PFoncSel=&LFonctions[0];
	gtk_widget_set_sensitive(PanoramaB,FALSE);
	gtk_widget_set_sensitive(LimCurvesB,FALSE);
	gtk_widget_set_sensitive(FamilyB,FALSE);
	gtk_widget_set_sensitive(LevelB,FALSE);
	gtk_widget_set_sensitive(CrossB,FALSE);
	gtk_widget_set_sensitive(InflexB,FALSE);
	gtk_widget_set_sensitive(FoncDelB,FALSE);
      }
    }
    if(!pf->pexpr->HasError()&&!pf->Diff&&!pf->Calc)CalculeFonction(&LFonctions[Sel]);
    if(pf->Diff){
      PFoncSel=pf;
      gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(FoncSelL)->entry),pf->nom);
      if(pf->Diff==1||pf->Diff==2||pf->Diff==3){
	gtk_widget_set_sensitive(PanoramaB,TRUE);
	gtk_widget_set_sensitive(LimCurvesB,TRUE);
	gtk_widget_set_sensitive(FamilyB,TRUE);
	gtk_widget_set_sensitive(CrossB,TRUE);
	gtk_widget_set_sensitive(InflexB,TRUE);
	gtk_widget_set_sensitive(FoncDelB,TRUE);
      }else{
	gtk_widget_set_sensitive(PanoramaB,FALSE);
	gtk_widget_set_sensitive(LimCurvesB,FALSE);
	gtk_widget_set_sensitive(FamilyB,FALSE);
	gtk_widget_set_sensitive(CrossB,FALSE);
	gtk_widget_set_sensitive(InflexB,FALSE);
	gtk_widget_set_sensitive(FoncDelB,FALSE);
      };
      if(pf->Diff==2)gtk_widget_set_sensitive(LevelB,TRUE);
      else gtk_widget_set_sensitive(LevelB,FALSE);
    }
    if(Sel&&!pf->pexpr->HasError())Ind|=UpdateDependencies(Sel);
    if(!pf->pexpr->HasError()&&(!pf->Diff||Ind)&&GTK_TOGGLE_BUTTON(RetraceCB)->active)
      Redraw();
  }
  delete[]ppfuncs;
}

char Fenetre::UpdateDependencies(int i)
{
  char flag=0;int j;TFonction*pf;
  for(j=1;j<!LFonctions;j++)if(j!=i&&LFonctions[j].pexpr->ContainFunc(LFonctions[i].func)){
    pf=&LFonctions[j];
     if(pf->Diff==0){
      RVar**ppvar=NULL;
      switch(pf->t){
      case 0:ppvar=&pxvar;break;
      case 1:ppvar=&pyvar;break;
      case 3:ppvar=&pavar;break;
      case 4:ppvar=&prvar;break;
      case 2:case 5:ppvar=&ptvar;break;}
      *pf->pexprder=pf->pexpr->Diff(**ppvar);
      pf->Calc=0;flag=1;CalculeFonction(pf);
    }else if(pf->Diff==1){
      RVar*ppvar[2];pf->Calc=1;
      if(!pf->LCourbes){pf->LCourbes.Destroy();flag=1;};
      switch(pf->t){
      case 0:case 1:case 2:ppvar[0]=pxvar;ppvar[1]=pyvar;break;
      };
      *pf->pexprder=pf->pexpr->Diff(*ppvar[0]);
      *pf->pexprder2=pf->pexpr->Diff(*ppvar[1]);
    }else{//pf->Diff==2 ou 3
      RVar*ppvar[4];pf->Calc=1;
      if(!pf->LCourbes){pf->LCourbes.Destroy();flag=1;};
      ppvar[0]=pxvar;ppvar[1]=pyvar;ppvar[2]=prvar;ppvar[3]=pavar;
      delete pf->pexprder;delete pf->pexprder2;
      pf->pexprder=DeriveX(pf->pexpr);pf->pexprder2=DeriveY(pf->pexpr);
    }
  }
  return flag;
}

void Fenetre::FListSelect(int n)
{
  Sel=n;FuncDialDisplay();
}

void Fenetre::FListUnselect()
{
  Sel=-1;FuncDialDisplay();
}

void Fenetre::FuncDialDisplay()
{
  if(Sel==-1)return;
  if(Sel){
    gtk_widget_set_sensitive(ActiveCB,TRUE);gtk_widget_set_sensitive(ExprEd,TRUE);
  }else{
    gtk_widget_set_sensitive(ActiveCB,FALSE);gtk_widget_set_sensitive(ExprEd,FALSE);
  }
  TFonction*pf=&LFonctions[Sel];
  FuncColor_temp=pf->hp->color;
  if(Sel)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ActiveCB),(pf->Active?TRUE:FALSE));
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ZCalcCB),(pf->ZCalc?TRUE:FALSE));
  if(Sel){char*s=pf->pexpr->Expr();gtk_entry_set_text(GTK_ENTRY(ExprEd),s);ExprEdCh=0;};
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(DiffRB),FALSE);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(FoncRB),FALSE);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(NivRB),FALSE);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ChampRB),FALSE);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(Diff2RB),FALSE);
  if(pf->Diff==0)gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(FoncRB),TRUE);
  else if(pf->Diff==1)gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(DiffRB),TRUE);
  else if(pf->Diff==2)gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(NivRB),TRUE);
  else if(pf->Diff==3)gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ChampRB),TRUE);
  else if(pf->Diff==4)gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(Diff2RB),TRUE);
  FixeTypes();
  gtk_clist_select_row(GTK_CLIST(TypeList),pf->t,0);
  FixeParams();
  char Texte[30]="";
  sprintf(Texte,"%g",pf->dr);gtk_entry_set_text(GTK_ENTRY(drEd),Texte);drEdCh=0;
  if(pf->minp==ErrVal)gtk_entry_set_text(GTK_ENTRY(minpEd),"screen");else
    {sprintf(Texte,"%g",pf->minp);gtk_entry_set_text(GTK_ENTRY(minpEd),Texte);};
  minpEdCh=0;
  if(pf->maxp==ErrVal)gtk_entry_set_text(GTK_ENTRY(maxpEd),"screen");else
    {sprintf(Texte,"%g",pf->maxp);gtk_entry_set_text(GTK_ENTRY(maxpEd),Texte);};
  maxpEdCh=0;
}

void Fenetre::FuncDestroy()
{
  if(Sel==-1||Sel==0)return;
  char flag=0;
  int i,j;
  for(j=1;j<!LFonctions;j++)if(LFonctions[j].pexpr->ContainFunc(LFonctions[Sel].func)){flag=1;break;}
  i=0;
  char Texte[strlen(LFonctions[Sel].nom)+100];
  if(flag)sprintf(Texte,"Destroy %s ?\nThis will destroy all functions depending on it.",LFonctions[Sel].nom);
  else sprintf(Texte,"Destroy %s ?",LFonctions[Sel].nom);
  if(AskDialog("Destroy",Texte)!=AskDialog_Yes)return;
  if(!LFonctions[Sel].LCourbes)i=1;
  if(LFonctions[Sel].Diff){
    FoncSelList=g_list_remove(FoncSelList,LFonctions[Sel].nom);
    gtk_combo_set_popdown_strings(GTK_COMBO(FoncSelL),FoncSelList);
    if(PFoncSel==&LFonctions[Sel]){
      gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(FoncSelL)->entry),"");
      PFoncSel=&LFonctions[0];
      gtk_widget_set_sensitive(PanoramaB,FALSE);
      gtk_widget_set_sensitive(LimCurvesB,FALSE);
      gtk_widget_set_sensitive(FamilyB,FALSE);
      gtk_widget_set_sensitive(LevelB,FALSE);
      gtk_widget_set_sensitive(CrossB,FALSE);
      gtk_widget_set_sensitive(InflexB,FALSE);
      gtk_widget_set_sensitive(FoncDelB,FALSE);
    }
  }
  if(flag)for(j=!LFonctions-1;j>0;j--)
    if(j!=Sel&&LFonctions[j].pexpr->ContainFunc(LFonctions[Sel].func)){
      FuncDestroyWithoutCheck(j);
      if(j<Sel)Sel--;  // Shift
    }
  int Sel2=Sel;
  gtk_clist_remove(GTK_CLIST(FList),StringInFList(LFonctions[Sel].nom));//sets Sel to -1
  LFonctions.DestroyObject(Sel2);//Sel=-1;
  if(GTK_TOGGLE_BUTTON(RetraceCB)->active&&i)Redraw();
  gtk_clist_select_row(GTK_CLIST(FList),0,0);
}

void Fenetre::FuncDestroyWithoutCheck(int s)
{
  if(s==-1||s==0)return;
  int i;if(!LFonctions[s].LCourbes)i=1;
  if(LFonctions[s].Diff){
    FoncSelList=g_list_remove(FoncSelList,LFonctions[s].nom);
    gtk_combo_set_popdown_strings(GTK_COMBO(FoncSelL),FoncSelList);
    if(PFoncSel==&LFonctions[s]){
      gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(FoncSelL)->entry),"");
      PFoncSel=&LFonctions[0];
      gtk_widget_set_sensitive(PanoramaB,FALSE);
      gtk_widget_set_sensitive(LimCurvesB,FALSE);
      gtk_widget_set_sensitive(FamilyB,FALSE);
      gtk_widget_set_sensitive(LevelB,FALSE);
      gtk_widget_set_sensitive(CrossB,FALSE);
      gtk_widget_set_sensitive(InflexB,FALSE);
      gtk_widget_set_sensitive(FoncDelB,FALSE);
    }
  }
  int s2=s;
  gtk_clist_remove(GTK_CLIST(FList),StringInFList(LFonctions[s].nom));//sets s to -1
  LFonctions.DestroyObject(s2);//s=-1;
}

void Fenetre::FuncNew()
{
  char* Nom;
  if(InputDialog("New function","Name of the function:","",&Nom)!=InputDialog_OK)return;
  if(!strlen(Nom)){MessageBox("New function","Empty name!");return;}
  for(int j=0;j<!LFonctions;j++)if(!strcmp(Nom,LFonctions[j].nom)){
    MessageBox("New function,","This name is preoccupied.");
    return;
  }
  TFonction*pf=new TFonction(Nom,new ROperation,LFonctions[0].dr,
			     new Pen(*LFonctions[0].hp),
			     LFonctions[0].Diff,LFonctions[0].t,LFonctions[0].ZCalc,
			     LFonctions[0].minp,LFonctions[0].maxp);
  GdkColormap *colormap;
  colormap = gdk_window_get_colormap (drawing_area->window);
  gdk_color_alloc (colormap, &pf->hp->color);
  //  pf->pexprder=new ROperation;pf->pexprder2=new ROperation;
  pf->Calc=0;
  LFonctions.AddObject(pf);
  char * pnom[1];pnom[0]=Nom;
  int i=gtk_clist_append(GTK_CLIST(FList),pnom);
  gtk_clist_select_row(GTK_CLIST(FList),i,0);
  FuncDialDisplay();
}

void Fenetre::FuncRen()
{
  if(Sel==-1||Sel==0)return;
  char *Nom;TFonction*pf=&LFonctions[Sel];
  if(InputDialog("Rename function","New name of the function:","",&Nom)!=InputDialog_OK)return;
  for(int j=0;j<!LFonctions;j++)if(!strcmp(Nom,LFonctions[j].nom)){
    MessageBox("Rename function,","This name is preoccupied.");
    return;
  }
  char *pnom[1];pnom[0]=Nom;
  int i=StringInFList(pf->nom);
  gtk_clist_remove(GTK_CLIST(FList),i);
  gtk_clist_insert(GTK_CLIST(FList),i,pnom);
  gtk_clist_select_row(GTK_CLIST(FList),i,0);
  if(pf->Diff){
    i=StringInFoncSelL(pf->nom);
    FoncSelList=g_list_remove(FoncSelList,pf->nom);
    FoncSelList=g_list_insert(FoncSelList,Nom,i);
    gtk_combo_set_popdown_strings(GTK_COMBO(FoncSelL),FoncSelList);
    if(PFoncSel==pf)gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(FoncSelL)->entry),Nom);
  }
  delete[](pf->nom);
  pf->nom=CopyStr(Nom);
  pf->func.SetName(Nom);
}

void Fenetre::FuncRecalc()
{
  if(Sel==0||Sel==-1)return;
  if(LFonctions[Sel].Diff)return;
  LFonctions[Sel].Calc=0;
  FuncOK();
}
