/*

Copyright Yann OLLIVIER 1997-1999

This software may be freely distributed as is, including
this whole notice.

It may be modified, but any modification should include this whole notice as 
is and a description of the changes made.

This software may not be sold.

This software or any modified version of it may be freely used in free
programs. The program should include a copy of this whole notice. If you
want to use it in a program you sell, contact me

This software comes with absolutely no warranty.

*/

#include "eqdiff.h"
                                   
void Fenetre::SetupFuncDial()
{
  GtkWidget *window,*scrwnd;
  GtkWidget *vbox,*hbox,*vbox2;
  GtkWidget *frame,*frame2;
  GtkWidget *label;
  GtkWidget *button;
  
  gchar *titles[2] = { "Functions","Type/Coordinates"};
  
  window=gtk_window_new(GTK_WINDOW_TOPLEVEL);FuncDial=window;
  
  gtk_window_set_title(GTK_WINDOW(window),"Functions");
  gtk_widget_show(window);
  gtk_signal_connect (GTK_OBJECT (window), "destroy",
      GTK_SIGNAL_FUNC (quit), NULL);
  
  vbox=gtk_vbox_new(FALSE,5);
  gtk_container_border_width(GTK_CONTAINER(vbox),5);
  gtk_container_add(GTK_CONTAINER(window),vbox);
  gtk_widget_show(vbox);
  
  hbox = gtk_hbox_new(FALSE,5);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  gtk_widget_show(hbox);
  {  
    button=gtk_button_new_with_label("Validate changes");FuncValB=button;
    gtk_box_pack_start(GTK_BOX(hbox),button,TRUE,TRUE,0);
    gtk_widget_show(button);
    button=gtk_button_new_with_label("New function");FuncNewB=button;
    gtk_box_pack_start(GTK_BOX(hbox),button,TRUE,TRUE,0);
    gtk_widget_show(button);
    button=gtk_button_new_with_label("Delete function");FuncDestroyB=button;
    gtk_box_pack_start(GTK_BOX(hbox),button,TRUE,TRUE,0);
    gtk_widget_show(button);
    button=gtk_button_new_with_label("Rename function");FuncRenB=button;
    gtk_box_pack_start(GTK_BOX(hbox),button,TRUE,TRUE,0);
    gtk_widget_show(button);
  }
  hbox = gtk_hbox_new(FALSE,5);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  gtk_widget_show(hbox);
  { 
    FList=gtk_clist_new_with_titles(1,titles);
    scrwnd=gtk_scrolled_window_new(NULL,NULL);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrwnd),GTK_POLICY_AUTOMATIC,GTK_POLICY_AUTOMATIC);
    gtk_widget_show(scrwnd);
    gtk_container_add(GTK_CONTAINER(scrwnd),FList);
    gtk_box_pack_start(GTK_BOX(hbox),scrwnd,TRUE,TRUE,0);
    gtk_widget_show(FList);
    
    NatureGB=gtk_frame_new("Nature");
    gtk_box_pack_start(GTK_BOX(hbox),NatureGB,TRUE,TRUE,0);
    gtk_widget_show(NatureGB);
    frame=gtk_frame_new(NULL);
    gtk_container_border_width(GTK_CONTAINER(frame),5);
    gtk_frame_set_shadow_type(GTK_FRAME(frame),GTK_SHADOW_NONE);
    gtk_container_add(GTK_CONTAINER(NatureGB),frame);
    gtk_widget_show(frame);
    {
      vbox2=gtk_vbox_new(FALSE,5);
      gtk_container_add(GTK_CONTAINER(frame),vbox2);
      gtk_widget_show(vbox2);
      {
	FoncRB=gtk_radio_button_new_with_label(NULL,"Function");
	DiffRB=gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(FoncRB)),"Diff. eq. order 1");
	NivRB=gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(DiffRB)),"Level curve");
	ChampRB=gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(NivRB)),"Gradient of a level curve");
	Diff2RB=gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(ChampRB)),"Diff. eq. order 2");
	OptB=gtk_button_new_with_label("Options...");
	gtk_box_pack_start(GTK_BOX(vbox2),FoncRB,TRUE,TRUE,0);
	gtk_box_pack_start(GTK_BOX(vbox2),DiffRB,TRUE,TRUE,0);
	gtk_box_pack_start(GTK_BOX(vbox2),NivRB,TRUE,TRUE,0);
	gtk_box_pack_start(GTK_BOX(vbox2),ChampRB,TRUE,TRUE,0);
	gtk_box_pack_start(GTK_BOX(vbox2),Diff2RB,TRUE,TRUE,0);
	gtk_box_pack_start(GTK_BOX(vbox2),OptB,TRUE,FALSE,0);
	gtk_widget_show(FoncRB);
	gtk_widget_show(DiffRB);
	gtk_widget_show(NivRB);
	gtk_widget_show(ChampRB);
	gtk_widget_hide(Diff2RB);
	gtk_widget_show(OptB);
      }
    }
  }
  frame2=gtk_frame_new("Formula");
  gtk_box_pack_start(GTK_BOX(vbox),frame2,TRUE,FALSE,0);
  gtk_widget_show(frame2);
  frame=gtk_frame_new(NULL);
  gtk_container_border_width(GTK_CONTAINER(frame),5);
  gtk_frame_set_shadow_type(GTK_FRAME(frame),GTK_SHADOW_NONE);
  gtk_container_add(GTK_CONTAINER(frame2),frame);
  gtk_widget_show(frame);
  {
    ExprEd=gtk_entry_new();
    gtk_container_add(GTK_CONTAINER(frame),ExprEd);
    gtk_widget_show(ExprEd);
  }
  hbox = gtk_hbox_new(FALSE,5);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  gtk_widget_show(hbox);
  {
    TypeList=gtk_clist_new_with_titles(1,&titles[1]);
    scrwnd=gtk_scrolled_window_new(NULL,NULL);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrwnd),GTK_POLICY_AUTOMATIC,GTK_POLICY_AUTOMATIC);
    gtk_widget_show(scrwnd);
    gtk_container_add(GTK_CONTAINER(scrwnd),TypeList);
    gtk_box_pack_start(GTK_BOX(hbox),scrwnd,TRUE,TRUE,0);
    gtk_widget_show(TypeList);
    
    frame2=gtk_frame_new("Precision");
    gtk_box_pack_start(GTK_BOX(hbox),frame2,TRUE,TRUE,0);
    gtk_widget_show(frame2);
    frame=gtk_frame_new("(computation, drawing)");
    gtk_container_border_width(GTK_CONTAINER(frame),5);
    gtk_frame_set_shadow_type(GTK_FRAME(frame),GTK_SHADOW_NONE);
    gtk_container_add(GTK_CONTAINER(frame2),frame);
    gtk_widget_show(frame);
    {
      drEd=gtk_entry_new();
      gtk_container_add(GTK_CONTAINER(frame),drEd);
      gtk_widget_show(drEd);
    }
  }
  IntSt=gtk_frame_new("Interval of x (or SCREEN)");
  gtk_box_pack_start(GTK_BOX(vbox),IntSt,TRUE,FALSE,0);
  gtk_widget_show(IntSt);
  frame=gtk_frame_new(NULL);
  gtk_container_border_width(GTK_CONTAINER(frame),5);
  gtk_frame_set_shadow_type(GTK_FRAME(frame),GTK_SHADOW_NONE);
  gtk_container_add(GTK_CONTAINER(IntSt),frame);
  gtk_widget_show(frame);
  {
    hbox=gtk_hbox_new(FALSE,5);
    gtk_container_add(GTK_CONTAINER(frame),hbox);
    gtk_widget_show(hbox);
    {
      label=gtk_label_new("From");
      gtk_box_pack_start(GTK_BOX(hbox),label,TRUE,TRUE,0);
      gtk_widget_show(label);
      minpEd=gtk_entry_new();
      gtk_box_pack_start(GTK_BOX(hbox),minpEd,TRUE,TRUE,0);
      gtk_widget_show(minpEd);
      label=gtk_label_new("to");
      gtk_box_pack_start(GTK_BOX(hbox),label,TRUE,TRUE,0);
      gtk_widget_show(label);
      maxpEd=gtk_entry_new();
      gtk_box_pack_start(GTK_BOX(hbox),maxpEd,TRUE,TRUE,0);
      gtk_widget_show(maxpEd);
    }
  }
  hbox = gtk_hbox_new(FALSE,5);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,FALSE,0);
  gtk_widget_show(hbox);
  {
    ActiveCB=gtk_check_button_new_with_label("Enable drawing this function");
    gtk_box_pack_start(GTK_BOX(hbox),ActiveCB,TRUE,TRUE,0);
    gtk_widget_show(ActiveCB);
    button=gtk_button_new_with_label("Color...");FuncColorB=button;
    gtk_box_pack_start(GTK_BOX(hbox),button,TRUE,TRUE,0);
    gtk_widget_show(button);
  }
  hbox = gtk_hbox_new(FALSE,5);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,FALSE,0);
  gtk_widget_show(hbox);
  {
    ZCalcCB=gtk_check_button_new_with_label("Recompute this function after zooming");
    gtk_box_pack_start(GTK_BOX(hbox),ZCalcCB,TRUE,TRUE,0);
    gtk_widget_show(ZCalcCB);
    button=gtk_button_new_with_label("Recompute this function now");RecalcB=button;
    gtk_box_pack_start(GTK_BOX(hbox),button,TRUE,TRUE,0);
    gtk_widget_show(button);
  }
  GtkWidget*separator;
  separator=gtk_hseparator_new();
  gtk_box_pack_start(GTK_BOX(vbox),separator,TRUE,TRUE,0);
  gtk_widget_show(separator);

  hbox = gtk_hbox_new(FALSE,5);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,FALSE,0);
  gtk_widget_show(hbox);
  {
    RetraceCB=gtk_check_button_new_with_label("Redraw after every change");
    gtk_box_pack_start(GTK_BOX(hbox),RetraceCB,TRUE,TRUE,0);
    gtk_widget_show(RetraceCB);
    button=gtk_button_new_with_label("Redraw now");Redraw2B=button;
    gtk_box_pack_start(GTK_BOX(hbox),button,TRUE,TRUE,0);
    gtk_widget_show(button);
  }

  int j;for(j=0;j<!LFonctions;j++)gtk_clist_append(GTK_CLIST(FList),&LFonctions[j].nom);
  Sel=-1;coord=-1;ExprEdCh=0;drEdCh=0;minpEdCh=0;maxpEdCh=0;
  gtk_clist_select_row(GTK_CLIST(FList),0,0);
  gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(RetraceCB),TRUE);
  FuncDialDisplay();
}                      


void Fenetre::SetupActDial()
{
  GtkWidget*window;
  GtkWidget *vbox,*hbox,*vbox2,*hbox2;
  GtkWidget *label;
  GtkWidget*separator;

  window=gtk_window_new(GTK_WINDOW_TOPLEVEL);ActDial=window;
  gtk_window_set_title(GTK_WINDOW(window),"Actions");
  gtk_widget_show(window);
  gtk_signal_connect (GTK_OBJECT (window), "destroy",
      GTK_SIGNAL_FUNC (quit), NULL);

  vbox=gtk_vbox_new(FALSE,5);
  gtk_container_border_width(GTK_CONTAINER(vbox),5);
  gtk_container_add(GTK_CONTAINER(window),vbox);
  gtk_widget_show(vbox);
  
  hbox = gtk_hbox_new(FALSE,5);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  gtk_widget_show(hbox);
  {
    vbox2=gtk_vbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(hbox),vbox2,FALSE,FALSE,0);
    gtk_widget_show(vbox2);
    XPos=gtk_label_new("x=");
    gtk_box_pack_start(GTK_BOX(vbox2),XPos,TRUE,TRUE,0);
    gtk_widget_show(XPos);
    YPos=gtk_label_new("y=");
    gtk_box_pack_start(GTK_BOX(vbox2),YPos,TRUE,TRUE,0);
    gtk_widget_show(YPos);
    vbox2=gtk_vbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(hbox),vbox2,FALSE,FALSE,0);
    gtk_widget_show(vbox2);
    RPos=gtk_label_new("r=");
    gtk_box_pack_start(GTK_BOX(vbox2),RPos,TRUE,TRUE,0);
    gtk_widget_show(RPos);
    APos=gtk_label_new("a=");
    gtk_box_pack_start(GTK_BOX(vbox2),APos,TRUE,TRUE,0);
    gtk_widget_show(APos);
  }
  hbox=gtk_hbox_new(FALSE,5);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  gtk_widget_show(hbox);
  {
    label=gtk_label_new("Selected function:");
    gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,0);
    gtk_widget_show(label);
    FoncSelL=gtk_combo_new();
    gtk_box_pack_start(GTK_BOX(hbox),FoncSelL,FALSE,FALSE,0);
    gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(FoncSelL)->entry),FALSE);
    gtk_widget_show(FoncSelL);
  }
  hbox=gtk_hbox_new(FALSE,5);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  gtk_widget_show(hbox);
  {
    ValSt=gtk_label_new("Value:");
    gtk_box_pack_start(GTK_BOX(hbox),ValSt,FALSE,FALSE,0);
    gtk_widget_show(ValSt);
  }
  hbox=gtk_hbox_new(FALSE,5);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  gtk_widget_show(hbox);
  {
    AbscSt1=gtk_label_new("Time or curv. absc.:");
    gtk_box_pack_start(GTK_BOX(hbox),AbscSt1,FALSE,FALSE,0);
    gtk_widget_show(AbscSt1);
    AbscSt2=gtk_label_new("");
    gtk_box_pack_start(GTK_BOX(hbox),AbscSt2,FALSE,FALSE,0);
    gtk_widget_show(AbscSt2);
  }

  separator=gtk_hseparator_new();
  gtk_box_pack_start(GTK_BOX(vbox),separator,TRUE,TRUE,0);
  gtk_widget_show(separator);

  hbox=gtk_hbox_new(FALSE,5);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  gtk_widget_show(hbox);
  {
    label=gtk_label_new("Action:");
    gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,0);
    gtk_widget_show(label);
  }
  hbox=gtk_hbox_new(FALSE,5);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  gtk_widget_show(hbox);
  {
    AideSt=gtk_label_new("Use the Functions window to create a new function.");
    gtk_box_pack_start(GTK_BOX(hbox),AideSt,FALSE,FALSE,0);
    gtk_widget_show(AideSt);
  }
  hbox=gtk_hbox_new(FALSE,5);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  gtk_widget_show(hbox);
  {
    label=gtk_label_new("From");
    gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,0);
    gtk_widget_show(label);
    vbox2=gtk_vbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(hbox),vbox2,TRUE,TRUE,0);
    gtk_widget_show(vbox2);
    CursorRB=gtk_radio_button_new_with_label(NULL,"the cursor");
    PointRB=gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(CursorRB)),"the point  -->");
    gtk_box_pack_start(GTK_BOX(vbox2),PointRB,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(vbox2),CursorRB,FALSE,FALSE,0);
    gtk_widget_show(CursorRB);gtk_widget_show(PointRB);
    separator=gtk_vseparator_new();
    gtk_box_pack_start(GTK_BOX(hbox),separator,TRUE,TRUE,0);
    gtk_widget_show(separator);
    vbox2=gtk_vbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(hbox),vbox2,TRUE,TRUE,0);
    gtk_widget_show(vbox2);
    hbox2=gtk_hbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(vbox2),hbox2,TRUE,TRUE,0);
    gtk_widget_show(hbox2);
    label=gtk_label_new("x=");
    gtk_box_pack_start(GTK_BOX(hbox2),label,TRUE,TRUE,0);
    gtk_widget_show(label);
    XEd=gtk_entry_new();
    gtk_box_pack_start(GTK_BOX(hbox2),XEd,TRUE,TRUE,0);
    gtk_widget_show(XEd);    
    hbox2=gtk_hbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(vbox2),hbox2,TRUE,TRUE,0);
    gtk_widget_show(hbox2);
    label=gtk_label_new("y=");
    gtk_box_pack_start(GTK_BOX(hbox2),label,TRUE,TRUE,0);
    gtk_widget_show(label);
    YEd=gtk_entry_new();
    gtk_box_pack_start(GTK_BOX(hbox2),YEd,TRUE,TRUE,0);
    gtk_widget_show(YEd);    
  }
  hbox=gtk_hbox_new(FALSE,5);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  gtk_widget_show(hbox);
  {
    vbox2=gtk_vbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(hbox),vbox2,TRUE,TRUE,0);
    gtk_widget_show(vbox2);
    PanoramaB=gtk_button_new_with_label("Panorama...");
    gtk_box_pack_start(GTK_BOX(vbox2),PanoramaB,FALSE,FALSE,0);
    gtk_widget_show(PanoramaB);
    LimCurvesB=gtk_button_new_with_label("Limit curves");
    gtk_box_pack_start(GTK_BOX(vbox2),LimCurvesB,FALSE,FALSE,0);
    gtk_widget_show(LimCurvesB);
    FamilyB=gtk_button_new_with_label("Family...");
    gtk_box_pack_start(GTK_BOX(vbox2),FamilyB,FALSE,FALSE,0);
    gtk_widget_show(FamilyB);
    LevelB=gtk_button_new_with_label("Look for level curve...");
    gtk_box_pack_start(GTK_BOX(vbox2),LevelB,FALSE,FALSE,0);
    gtk_widget_show(LevelB);
    CrossB=gtk_button_new_with_label("Look for crossing");
    gtk_box_pack_start(GTK_BOX(vbox2),CrossB,FALSE,FALSE,0);
    gtk_widget_show(CrossB);
    InflexB=gtk_button_new_with_label("Look for inflection points");
    gtk_box_pack_start(GTK_BOX(vbox2),InflexB,FALSE,FALSE,0);
    gtk_widget_show(InflexB);
    
    separator=gtk_vseparator_new();
    gtk_box_pack_start(GTK_BOX(hbox),separator,TRUE,TRUE,0);
    gtk_widget_show(separator);

    vbox2=gtk_vbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(hbox),vbox2,TRUE,TRUE,0);
    gtk_widget_show(vbox2);
    TraceCB=gtk_check_button_new_with_label("Trace");
    gtk_box_pack_start(GTK_BOX(vbox2),TraceCB,FALSE,FALSE,0);
    gtk_widget_show(TraceCB);
    RedrawB=gtk_button_new_with_label("Redraw");
    gtk_box_pack_start(GTK_BOX(vbox2),RedrawB,FALSE,FALSE,0);
    gtk_widget_show(RedrawB);
    ZoomB=gtk_button_new_with_label("Zoom parameters...");
    gtk_box_pack_start(GTK_BOX(vbox2),ZoomB,FALSE,FALSE,0);
    gtk_widget_show(ZoomB);
    AxesB=gtk_button_new_with_label("Axes parameters...");
    gtk_box_pack_start(GTK_BOX(vbox2),AxesB,FALSE,FALSE,0);
    gtk_widget_show(AxesB);
    CrbDelB=gtk_button_new_with_label("Delete curve below cursor");
    gtk_box_pack_start(GTK_BOX(vbox2),CrbDelB,FALSE,FALSE,0);
    gtk_widget_show(CrbDelB);
    label=gtk_label_new("(rather use right mouse button)");
    gtk_box_pack_start(GTK_BOX(vbox2),label,FALSE,FALSE,0);
    gtk_widget_show(label);
    FoncDelB=gtk_button_new_with_label("Delete curves of function");
    gtk_box_pack_start(GTK_BOX(vbox2),FoncDelB,FALSE,FALSE,0);
    gtk_widget_show(FoncDelB);
  }

  separator=gtk_hseparator_new();
  gtk_box_pack_start(GTK_BOX(vbox),separator,TRUE,TRUE,0);
  gtk_widget_show(separator);

  hbox=gtk_hbox_new(FALSE,5);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  gtk_widget_show(hbox);
  {
    SaveB=gtk_button_new_with_label("Save functions to file");
    gtk_box_pack_start(GTK_BOX(hbox),SaveB,TRUE,TRUE,5);
    gtk_widget_show(SaveB);
    LoadB=gtk_button_new_with_label("Load functions from file");
    gtk_box_pack_start(GTK_BOX(hbox),LoadB,TRUE,TRUE,5);
    gtk_widget_show(LoadB);
    MergeB=gtk_button_new_with_label("Merge from file");
    gtk_box_pack_start(GTK_BOX(hbox),MergeB,TRUE,TRUE,5);
    gtk_widget_show(MergeB);
  }
  hbox=gtk_hbox_new(FALSE,5);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  gtk_widget_show(hbox);
  {
    SaveImageXPMB=gtk_button_new_with_label("Save as xpm");
    gtk_box_pack_start(GTK_BOX(hbox),SaveImageXPMB,TRUE,TRUE,5);
    gtk_widget_show(SaveImageXPMB);
    SaveImagePPMB=gtk_button_new_with_label("Save as ppm");
    gtk_box_pack_start(GTK_BOX(hbox),SaveImagePPMB,TRUE,TRUE,5);
    gtk_widget_show(SaveImagePPMB);
  }
}

void Fenetre::SetupZoomDial()
{
  GtkWidget *window,*hbox,*vbox,*label,*vbox2,*frame,*frame2,*button,*separator;

  window=gtk_window_new(GTK_WINDOW_TOPLEVEL);ZoomDial=window;
  gtk_window_set_title(GTK_WINDOW(window),"Zoom parameters");
  //  gtk_widget_show(window);
  
  vbox=gtk_vbox_new(FALSE,5);
  gtk_container_border_width(GTK_CONTAINER(vbox),5);
  gtk_container_add(GTK_CONTAINER(window),vbox);
  gtk_widget_show(vbox);

  frame2=gtk_frame_new("Centre");
  gtk_box_pack_start(GTK_BOX(vbox),frame2,TRUE,TRUE,0);
  gtk_widget_show(frame2);
  frame=gtk_frame_new(NULL);
  gtk_container_border_width(GTK_CONTAINER(frame),5);
  gtk_frame_set_shadow_type(GTK_FRAME(frame),GTK_SHADOW_NONE);
  gtk_container_add(GTK_CONTAINER(frame2),frame);
  gtk_widget_show(frame);
  {
    vbox2=gtk_vbox_new(FALSE,5);
    gtk_container_add(GTK_CONTAINER(frame),vbox2);
    gtk_widget_show(vbox2);
    hbox=gtk_hbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(vbox2),hbox,TRUE,TRUE,0);
    gtk_widget_show(hbox);
    {
      label=gtk_label_new("x=");
      gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,0);
      gtk_widget_show(label);
      xlcEd=gtk_entry_new();
      gtk_box_pack_start(GTK_BOX(hbox),xlcEd,FALSE,FALSE,0);
      gtk_widget_show(xlcEd);
    }
    hbox=gtk_hbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(vbox2),hbox,TRUE,TRUE,0);
    gtk_widget_show(hbox);
    {
      label=gtk_label_new("y=");
      gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,0);
      gtk_widget_show(label);
      ylcEd=gtk_entry_new();
      gtk_box_pack_start(GTK_BOX(hbox),ylcEd,FALSE,FALSE,0);
      gtk_widget_show(ylcEd);
    }
  }
  hbox=gtk_hbox_new(FALSE,5);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  gtk_widget_show(hbox);
  {
    vbox2=gtk_vbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(hbox),vbox2,FALSE,FALSE,0);
    gtk_widget_show(vbox2);
    label=gtk_label_new("Horizontal range:");
    gtk_box_pack_start(GTK_BOX(vbox2),label,TRUE,TRUE,0);
    gtk_widget_show(label);
    label=gtk_label_new("Vertical range:");
    gtk_box_pack_start(GTK_BOX(vbox2),label,TRUE,TRUE,0);
    gtk_widget_show(label);
    vbox2=gtk_vbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(hbox),vbox2,FALSE,FALSE,0);
    gtk_widget_show(vbox2);
    xechEd=gtk_entry_new();
    gtk_box_pack_start(GTK_BOX(vbox2),xechEd,TRUE,TRUE,0);
    gtk_widget_show(xechEd);
    yechEd=gtk_entry_new();
    gtk_box_pack_start(GTK_BOX(vbox2),yechEd,TRUE,TRUE,0);
    gtk_widget_show(yechEd);
  }

  frame2=gtk_frame_new("Adjustment to the window");
  gtk_box_pack_start(GTK_BOX(vbox),frame2,TRUE,TRUE,0);
  gtk_widget_show(frame2);
  frame=gtk_frame_new(NULL);
  gtk_container_border_width(GTK_CONTAINER(frame),5);
  gtk_frame_set_shadow_type(GTK_FRAME(frame),GTK_SHADOW_NONE);
  gtk_container_add(GTK_CONTAINER(frame2),frame);
  gtk_widget_show(frame);
  {
    vbox2=gtk_vbox_new(FALSE,5);
    gtk_container_add(GTK_CONTAINER(frame),vbox2);
    gtk_widget_show(vbox2);
    xyWRB=gtk_radio_button_new_with_label(NULL,"x and y adapted to the window");
    xWRB=gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(xyWRB)),"x adjusted to the window, y constrained");
    yWRB=gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(xWRB)),"y adjusted to the window, x constrained");
    gtk_box_pack_start(GTK_BOX(vbox2),xyWRB,TRUE,TRUE,0);
    gtk_box_pack_start(GTK_BOX(vbox2),xWRB,TRUE,TRUE,0);
    gtk_box_pack_start(GTK_BOX(vbox2),yWRB,TRUE,TRUE,0);
    gtk_widget_show(xyWRB);gtk_widget_show(xWRB);gtk_widget_show(yWRB);
    hbox=gtk_hbox_new(FALSE,0);
    gtk_box_pack_start(GTK_BOX(vbox2),hbox,TRUE,TRUE,0);
    gtk_widget_show(hbox);
    label=gtk_label_new("Constriction ratio y/x=");
    gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,0);
    gtk_widget_show(label);
    xyEd=gtk_entry_new();
    gtk_box_pack_start(GTK_BOX(hbox),xyEd,FALSE,FALSE,0);
    gtk_widget_show(xyEd);
    hbox=gtk_hbox_new(FALSE,0);
    gtk_box_pack_start(GTK_BOX(vbox2),hbox,TRUE,TRUE,0);
    gtk_widget_show(hbox);
    label=gtk_label_new("Window ratio aspect y/x=");
    gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,0);
    gtk_widget_show(label);
    WAspEd=gtk_entry_new();
    gtk_box_pack_start(GTK_BOX(hbox),WAspEd,FALSE,FALSE,0);
    gtk_widget_show(WAspEd);
  }
  separator=gtk_hseparator_new();
  gtk_box_pack_start(GTK_BOX(vbox),separator,TRUE,TRUE,5);
  gtk_widget_show(separator);
  hbox=gtk_hbox_new(FALSE,5);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  gtk_widget_show(hbox);
  button=gtk_button_new_with_label("OK");ZoomDialogOKB=button;
  gtk_box_pack_start(GTK_BOX(hbox),button,TRUE,TRUE,0);
  gtk_widget_show(button);
  button=gtk_button_new_with_label("Cancel");ZoomDialogCancelB=button;
  gtk_box_pack_start(GTK_BOX(hbox),button,TRUE,TRUE,0);
  gtk_widget_show(button);

}

void Fenetre::SetupAxesDial()
{
  GtkWidget *window,*hbox,*vbox,*label,*vbox2,*frame,*frame2,*button,*separator;

  window=gtk_window_new(GTK_WINDOW_TOPLEVEL);AxesDial=window;
  gtk_window_set_title(GTK_WINDOW(window),"Axes parameters");
  //  gtk_widget_show(window);
  
  vbox=gtk_vbox_new(FALSE,5);
  gtk_container_border_width(GTK_CONTAINER(vbox),5);
  gtk_container_add(GTK_CONTAINER(window),vbox);
  gtk_widget_show(vbox);

  frame2=gtk_frame_new("Axes crossing at");
  gtk_box_pack_start(GTK_BOX(vbox),frame2,TRUE,TRUE,0);
  gtk_widget_show(frame2);
  frame=gtk_frame_new(NULL);
  gtk_container_border_width(GTK_CONTAINER(frame),5);
  gtk_frame_set_shadow_type(GTK_FRAME(frame),GTK_SHADOW_NONE);
  gtk_container_add(GTK_CONTAINER(frame2),frame);
  gtk_widget_show(frame);
  {
    vbox2=gtk_vbox_new(FALSE,5);
    gtk_container_add(GTK_CONTAINER(frame),vbox2);
    gtk_widget_show(vbox2);
    hbox=gtk_hbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(vbox2),hbox,TRUE,TRUE,0);
    gtk_widget_show(hbox);
    {
      label=gtk_label_new("x=");
      gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,0);
      gtk_widget_show(label);
      xaxeEd=gtk_entry_new();
      gtk_box_pack_start(GTK_BOX(hbox),xaxeEd,FALSE,FALSE,0);
      gtk_widget_show(xaxeEd);
    }
    hbox=gtk_hbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(vbox2),hbox,TRUE,TRUE,0);
    gtk_widget_show(hbox);
    {
      label=gtk_label_new("y=");
      gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,0);
      gtk_widget_show(label);
      yaxeEd=gtk_entry_new();
      gtk_box_pack_start(GTK_BOX(hbox),yaxeEd,FALSE,FALSE,0);
      gtk_widget_show(yaxeEd);
    }
  }

  frame2=gtk_frame_new("Graduation interval");
  gtk_box_pack_start(GTK_BOX(vbox),frame2,TRUE,TRUE,0);
  gtk_widget_show(frame2);
  frame=gtk_frame_new(NULL);
  gtk_container_border_width(GTK_CONTAINER(frame),5);
  gtk_frame_set_shadow_type(GTK_FRAME(frame),GTK_SHADOW_NONE);
  gtk_container_add(GTK_CONTAINER(frame2),frame);
  gtk_widget_show(frame);
  {
    vbox2=gtk_vbox_new(FALSE,5);
    gtk_container_add(GTK_CONTAINER(frame),vbox2);
    gtk_widget_show(vbox2);
    hbox=gtk_hbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(vbox2),hbox,TRUE,TRUE,0);
    gtk_widget_show(hbox);
    {
      label=gtk_label_new("x axis");
      gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,0);
      gtk_widget_show(label);
      xgradEd=gtk_entry_new();
      gtk_box_pack_start(GTK_BOX(hbox),xgradEd,FALSE,FALSE,0);
      gtk_widget_show(xgradEd);
    }
    hbox=gtk_hbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(vbox2),hbox,TRUE,TRUE,0);
    gtk_widget_show(hbox);
    {
      label=gtk_label_new("y axis");
      gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,0);
      gtk_widget_show(label);
      ygradEd=gtk_entry_new();
      gtk_box_pack_start(GTK_BOX(hbox),ygradEd,FALSE,FALSE,0);
      gtk_widget_show(ygradEd);
    }
  }

  hbox=gtk_hbox_new(FALSE,5);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  gtk_widget_show(hbox);
  button=gtk_button_new_with_label("Axes color...");AxesColorB=button;
  gtk_box_pack_start(GTK_BOX(hbox),button,TRUE,TRUE,0);
  gtk_widget_show(button);
  button=gtk_button_new_with_label("Window background color...");WColorB=button;
  gtk_box_pack_start(GTK_BOX(hbox),button,TRUE,TRUE,0);
  gtk_widget_show(button);

  separator=gtk_hseparator_new();
  gtk_box_pack_start(GTK_BOX(vbox),separator,TRUE,TRUE,5);
  gtk_widget_show(separator);
  hbox=gtk_hbox_new(FALSE,5);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  gtk_widget_show(hbox);
  AxesDialogOKB=gtk_button_new_with_label("OK");
  gtk_box_pack_start(GTK_BOX(hbox),AxesDialogOKB,TRUE,TRUE,0);
  gtk_widget_show(AxesDialogOKB);
  AxesDialogCancelB=gtk_button_new_with_label("Cancel");
  gtk_box_pack_start(GTK_BOX(hbox),AxesDialogCancelB,TRUE,TRUE,0);
  gtk_widget_show(AxesDialogCancelB);

}

void Fenetre::SetupOptDial()
{
  GtkWidget *window,*hbox,*vbox,*vbox2,*frame,*frame2,*button,*separator;

  window=gtk_window_new(GTK_WINDOW_TOPLEVEL);OptDial=window;
  gtk_window_set_title(GTK_WINDOW(window),"Options");
  //  gtk_widget_show(window);
  
  vbox=gtk_vbox_new(FALSE,5);
  gtk_container_border_width(GTK_CONTAINER(vbox),5);
  gtk_container_add(GTK_CONTAINER(window),vbox);
  gtk_widget_show(vbox);

  frame2=gtk_frame_new("Singularity");
  gtk_box_pack_start(GTK_BOX(vbox),frame2,TRUE,TRUE,0);
  gtk_widget_show(frame2);
  frame=gtk_frame_new(NULL);
  gtk_container_border_width(GTK_CONTAINER(frame),5);
  gtk_frame_set_shadow_type(GTK_FRAME(frame),GTK_SHADOW_NONE);
  gtk_container_add(GTK_CONTAINER(frame2),frame);
  gtk_widget_show(frame);
  {
    vbox2=gtk_vbox_new(FALSE,5);
    gtk_container_add(GTK_CONTAINER(frame),vbox2);
    gtk_widget_show(vbox2);
    ArrRB=gtk_radio_button_new_with_label(NULL,"Stop");
    ContRB=gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(ArrRB)),"Try to go on");
    gtk_box_pack_start(GTK_BOX(vbox2),ArrRB,TRUE,TRUE,0);
    gtk_box_pack_start(GTK_BOX(vbox2),ContRB,TRUE,TRUE,0);
    gtk_widget_show(ArrRB);gtk_widget_show(ContRB);
  }

  frame2=gtk_frame_new("Interrupt drawing when");
  gtk_box_pack_start(GTK_BOX(vbox),frame2,TRUE,TRUE,0);
  gtk_widget_show(frame2);
  frame=gtk_frame_new(NULL);
  gtk_container_border_width(GTK_CONTAINER(frame),5);
  gtk_frame_set_shadow_type(GTK_FRAME(frame),GTK_SHADOW_NONE);
  gtk_container_add(GTK_CONTAINER(frame2),frame);
  gtk_widget_show(frame);
  {
    vbox2=gtk_vbox_new(FALSE,5);
    gtk_container_add(GTK_CONTAINER(frame),vbox2);
    gtk_widget_show(vbox2);
    TestPtICB=gtk_check_button_new_with_label("Passing near the starting point");
    TestPtsCB=gtk_check_button_new_with_label("Passing near an already drawn point");
    gtk_box_pack_start(GTK_BOX(vbox2),TestPtICB,TRUE,TRUE,0);
    gtk_box_pack_start(GTK_BOX(vbox2),TestPtsCB,TRUE,TRUE,0);
    gtk_widget_show(TestPtICB);gtk_widget_show(TestPtsCB);
  }

  separator=gtk_hseparator_new();
  gtk_box_pack_start(GTK_BOX(vbox),separator,TRUE,TRUE,5);
  gtk_widget_show(separator);
  hbox=gtk_hbox_new(FALSE,5);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  gtk_widget_show(hbox);
  button=gtk_button_new_with_label("OK");OptDialogOKB=button;
  gtk_box_pack_start(GTK_BOX(hbox),button,TRUE,TRUE,0);
  gtk_widget_show(button);
  button=gtk_button_new_with_label("Cancel");OptDialogCancelB=button;
  gtk_box_pack_start(GTK_BOX(hbox),button,TRUE,TRUE,0);
  gtk_widget_show(button);

}
